%define tartype community

%define Werror_cflags %nil

%define _disable_ld_no_undefined 1

Summary:	A MySQL visual database modeling, administration, development and migration tool
Name:		mysql-workbench
Group:		Databases
Version:	6.3.9
Release:	%mkrel 1
License:	GPLv2
URL:        	http://wb.mysql.com
Source0:    	http://cdn.mysql.com/Downloads/MySQLGUITools/mysql-workbench-%{tartype}-%{version}-src.tar.gz
Source1: 	http://www.antlr3.org/download/antlr-3.4-complete.jar
# From Arch Linux
Patch0001:      0001-mysql-workbench-no-check-for-updates.patch
Patch0002:      0002-disable-unsupported-operating-system-warning.patch
Patch0003:      0003-add-option-to-hide-nonstandard-server-warning.patch
Patch0004:      0004-fix-build-for-i686.patch

Patch0005:      mysql-workbench-community-6.3.9-fix-build.patch

Obsoletes:	mysql-workbench-oss < 5.2.30
Provides:	mysql-workbench
Obsoletes:      mysql-gui-tools < 5.1
Provides:       mysql-gui-tools
Obsoletes:      mysql-administrator < 5.1
Provides:       mysql-administrator
Obsoletes:	mysql-utilities
BuildRequires:	ant
BuildRequires:	ant-antlr
BuildRequires:	antlr3-C-devel
BuildRequires:	autoconf2.5
BuildRequires:	boost-devel >= 1.35.0
BuildRequires:	cairo-devel
BuildRequires:	cairomm-devel
BuildRequires:	cmake
BuildRequires:	ctemplate-devel >= 0.91
BuildRequires:	ecj
BuildRequires:	expat-devel
BuildRequires:	fdupes
BuildRequires:	file
BuildRequires:	freetype2-devel >= 2.1.10
BuildRequires:	gcj-tools
BuildRequires:	gdal-devel
BuildRequires:	gettext
BuildRequires:	gettext-devel
BuildRequires:	glib2-devel
BuildRequires:	glibmm2.4-devel
BuildRequires:	gtk2-devel
BuildRequires:	gtkhtml-3.14-devel
BuildRequires:	gtkmm2.4-devel >= 2.6
BuildRequires:	imagemagick
BuildRequires:	iodbc-devel
BuildRequires:	jpackage-utils
BuildRequires:	junit
BuildRequires:	libext2fs-devel
BuildRequires:	libfcgi-devel
BuildRequires:	libfontconfig-devel
BuildRequires:	libglade2.0-devel >= 2.5
BuildRequires:	libgnome2-devel
BuildRequires:	libgnome-keyring-devel
BuildRequires:	libgnomeprint-devel >= 2.2.0
BuildRequires:	libpng-devel
BuildRequires:	libsigc++2.0-devel
BuildRequires:	libslang-devel
BuildRequires:	libtool
BuildRequires:	libuuid-devel
BuildRequires:	libx11-devel
BuildRequires:	libxext-devel
BuildRequires:	libxml2-devel
BuildRequires:	libxrender-devel
BuildRequires:	libzip-devel
BuildRequires:	lua5.1-devel
BuildRequires:	mariadb-devel >= 5.0
BuildRequires:	mariadb-embedded-devel
BuildRequires:	mesagl-devel
BuildRequires:	mesaglu-devel
BuildRequires:	mysql-connector-c++-devel >= 1.1.8
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:	pcrecpp-devel
BuildRequires:	pcre-devel >= 5.0
BuildRequires:	pixman-devel >= 0.11.2
BuildRequires:	pkgconfig
BuildRequires:	python-devel
BuildRequires:	python-paramiko
BuildRequires:	readline-devel
BuildRequires:	scintilla-devel
BuildRequires:	sqlite3-devel
BuildRequires:	swig
BuildRequires:	termcap-devel
BuildRequires:	tinyxml-devel
BuildRequires:	vsqlite++-devel
BuildRequires:  pkgconfig(gtkmm-3.0)

# requires mysql-client (for mysqldump and mysql cmdline client)
Requires:	mysql-client
Requires:	gnome-keyring
Requires:	python-paramiko
Requires:	python-pexpect
Requires:	libiodbc-admin


%description
MySQL Workbench is a unified visual tool for database architects, developers,
and DBAs. MySQL Workbench provides data modeling, SQL development, and
comprehensive administration tools for server configuration, user
administration, backup, and much more. MySQL Workbench is available on
Windows, Linux and Mac OS X
This is the %{tartype} build.


%prep
mkdir -p linux-res/bin/
cp %{SOURCE1} linux-res/bin/
%setup -q -n mysql-workbench-%{tartype}-%{version}-src
%autopatch -p1

sed -ie 's/ReloadIfChanged/ReloadAllIfChanged/g' backend/wbpublic/sqlide/recordset_text_storage.cpp

# make cmake happy with mariadb
sed -i '/^find_package(MySQL /c find_package(MySQL REQUIRED)' \
	CMakeLists.txt

# we need python 2.x
sed -i '/^FIND_PROGRAM(PYTHON_EXEC /c FIND_PROGRAM(PYTHON_EXEC "python2")' \
	CMakeLists.txt

# fix GDAL
sed -i '/#include/s|gdal/||' \
	backend/wbpublic/grtui/geom_draw_box.h \
	backend/wbpublic/grt/spatial_handler.h \
	backend/wbpublic/objimpl/db.query/db_query_Resultset.cpp

# put antlr into place
install -D %{_sourcedir}/antlr-3.4-complete.jar linux-res/bin/antlr-3.4-complete.jar

%build
export CXXFLAGS="%{optflags} -fpermissive -std=c++11"
%cmake
%make

%install
touch LICENSE.mysql
%make_install -C build

# construct a clean and correct wrapper
cat > %{buildroot}%{_bindir}/mysql-workbench << EOF
#!/bin/bash
export LD_LIBRARY_PATH="%{_libdir}/mysql-workbench:\$LD_LIBRARY_PATH"
export MWB_DATA_DIR="%{_datadir}/mysql-workbench"
export MWB_LIBRARY_DIR="%{_datadir}/mysql-workbench/libraries"
export MWB_MODULE_DIR="%{_libdir}/mysql-workbench/modules"
export MWB_PLUGIN_DIR="%{_libdir}/mysql-workbench/plugins"
export DBC_DRIVER_PATH="%{_libdir}/mysql-workbench"
export MWB_BINARIES_DIR="%{_bindir}"
%{_bindir}/mysql-workbench-bin \$*
EOF

# fix some menu entries and stuff...
install -d %{buildroot}%{_miconsdir}
install -d %{buildroot}%{_iconsdir}
install -d %{buildroot}%{_liconsdir}

install -d %{buildroot}%{_datadir}/applications
rm -f %{buildroot}%{_datadir}/applications/MySQLWorkbench.desktop
cat > %{buildroot}%{_datadir}/applications/mysql-workbench.desktop << EOF
[Desktop Entry]
Name=MySQL Workbench
Comment=MySQL Database Design Tool
Exec=%{_bindir}/mysql-workbench
Terminal=false
Type=Application
Icon=mysql-workbench
Categories=Database;Office;
EOF

# make some icons
convert %{buildroot}%{_datadir}/mysql-workbench/images/MySQLWorkbench-128.png -resize 16x16 %{buildroot}%{_miconsdir}/mysql-workbench.png
convert %{buildroot}%{_datadir}/mysql-workbench/images/MySQLWorkbench-128.png -resize 32x32 %{buildroot}%{_iconsdir}/mysql-workbench.png
convert %{buildroot}%{_datadir}/mysql-workbench/images/MySQLWorkbench-128.png -resize 48x48 %{buildroot}%{_liconsdir}/mysql-workbench.png

# cleanup static libs
rm -f %{buildroot}%{_libdir}/mysql-workbench/*.*a
#rm -f %%{buildroot}%%{_libdir}/mysql-workbench/lib*.so
rm -f %{buildroot}%{_libdir}/mysql-workbench/modules/*.*a
rm -f %{buildroot}%{_libdir}/mysql-workbench/plugins/*.*a

%files
%doc AUTHORS COPYING COPYING.LGPL README samples
%{_bindir}/%{name}
%{_bindir}/%{name}-bin
%{_bindir}/wbcopytables-bin
%{_bindir}/wbcopytables
%{_datadir}/applications/mysql-workbench.desktop
%{_miconsdir}/mysql-workbench.png
%{_iconsdir}/mysql-workbench.png
%{_liconsdir}/mysql-workbench.png
%{_iconsdir}/hicolor/*
%{_libdir}/%{name}
%{_datadir}/%{name}
%{_datadir}/mime/packages/*
%{_datadir}/mime-info/*


%changelog
* Sat Apr 29 2017 neoclust <neoclust> 6.3.9-1.mga6
+ Revision: 1098016
- New version 6.3.9 - Fixes CVE-2016-2176, CVE-2017-3469, and CVE-2016-6303 (mga#20728)

* Sat Mar 12 2016 daviddavid <daviddavid> 6.3.6-2.mga6
+ Revision: 989507
- switch BR to ecj (eclipse-ecj is no more provided)
- fix License

* Sun Jan 10 2016 wally <wally> 6.3.6-1.mga6
+ Revision: 920960
- new version 6.3.6
- sync patches and build fixes with Arch Linux
- build with -std=c++11

* Mon Feb 23 2015 spuhler <spuhler> 6.2.4-1.mga5
+ Revision: 816703
- upgrade to version 6.2.4
  * version required for mariadb-10.0.x
  * needed to fix bug #14621
- cleaned spec file and removed old vers. 5.2.x patches
- added patch from Opensuse to prevent from asking for upgrades
 * we provide upgrades from Mageia

  + umeabot <umeabot>
    - Second Mageia 5 Mass Rebuild
    - Mageia 5 Mass Rebuild

  + tv <tv>
    - s/uggests:/Recommends:/
    - rebuild with lua-5.2

  + dlucio <dlucio>
    - 6.1.7
    - Lua5.1 required

* Fri May 02 2014 dlucio <dlucio> 6.1.4-1.mga5
+ Revision: 619645
- 6.1.4
- P6 dropped
- LDFLAGS export variable
- filelist fixed
- 6.0.7

* Sat Oct 19 2013 umeabot <umeabot> 6.0.6-5.mga4
+ Revision: 533501
- Mageia 4 Mass Rebuild

* Sat Aug 31 2013 dlucio <dlucio> 6.0.6-4.mga4
+ Revision: 473631
- mysql-utilities as suggests

* Fri Aug 30 2013 dlucio <dlucio> 6.0.6-3.mga4
+ Revision: 473253
- p6 renabled
- libiodbc-admin as require
- bin wrapper was missing MWB_BINARIES_DIR

* Fri Aug 30 2013 dlucio <dlucio> 6.0.6-2.mga4
+ Revision: 473225
- dont delete .la or .so by now

* Fri Aug 30 2013 dlucio <dlucio> 6.0.6-1.mga4
+ Revision: 473189
- cmake as BR
- 6.0.6
- all Ps dropped

* Thu Aug 29 2013 dlucio <dlucio> 5.2.45-4.mga4
+ Revision: 472857
- bump release

* Mon Apr 01 2013 juancho <juancho> 5.2.45-3.mga3
+ Revision: 406908
- Excluded python mysql connector from mysql-utilities so it doesn't conflict with mysql-connector-python (bug #9421)

* Fri Jan 18 2013 fwang <fwang> 5.2.45-2.mga3
+ Revision: 389331
- rebuild

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Jan 05 2013 juancho <juancho> 5.2.45-1.mga3
+ Revision: 339044
- Updated to 5.2.45
- Synced patches with Fedora
- General spec cleanup

* Sat Dec 01 2012 fwang <fwang> 5.2.44-5.mga3
+ Revision: 323851
- rebuild
- bump req
- rebuild for new pcre

* Wed Nov 21 2012 juancho <juancho> 5.2.44-3.mga3
+ Revision: 320349
- Added patch form Fedora to remove documentation because it isn't licenced under the GPL.

* Fri Oct 19 2012 fwang <fwang> 5.2.44-2.mga3
+ Revision: 308110
- utilities is not a noarch package

* Fri Oct 19 2012 juancho <juancho> 5.2.44-1.mga3
+ Revision: 308061
- Updated to 5.2.44
- Updated all patches, taken from package 5.2.43 from Fedora
- Removed old patches
- Added new BR for iodbc-devel and antlr3-C-devel

* Mon Aug 06 2012 fwang <fwang> 5.2.36-3.mga3
+ Revision: 279444
- rebuild for new ctemplate

* Wed Apr 04 2012 dlucio <dlucio> 5.2.36-2.mga2
+ Revision: 228302
- fix for automake
- P1 rediffed, we need to call .so.6 not .5

* Sun Dec 18 2011 dlucio <dlucio> 5.2.36-1.mga2
+ Revision: 184054
- fix file list
- 5.2.36
  P5 dropped
  P7 to fix new gnome3 include architecture
- Rebuild, lets build against libmysqlcppconn6

  + fwang <fwang>
    - update file list
    - rediff some patches

* Sat May 21 2011 dmorgan <dmorgan> 5.2.33b-1.mga1
+ Revision: 100085
- Fix file list
- Fix file list
- Do not delete folders ( for now )
- Backport fedora spec file fix
- Package mysql-utilities
  Add more obsoletes
- Obsolete old mysql-gui-tools

* Fri Apr 08 2011 mikala <mikala> 5.2.33b-0.mga1
+ Revision: 82323
- Update tarball to 5.2.33b
- Rediff patch1->4 against 5.2.33b

* Wed Mar 16 2011 mikala <mikala> 5.2.31-6.mga1
+ Revision: 72282
- Add patch6 to fix ifconfig path as suggested by misc

* Tue Mar 15 2011 mikala <mikala> 5.2.31-5.mga1
+ Revision: 72089
- Rediff patch1 to match new soname of mysql-connector-c++

* Mon Mar 07 2011 ahmad <ahmad> 5.2.31-4.mga1
+ Revision: 65769
- add requires on gnome-keyring
- add requires on mysql-client (Fedora)
- remove duplicate BR

* Mon Mar 07 2011 spuhler <spuhler> 5.2.31-3.mga1
+ Revision: 65753
- added Rquires: python-pexpect

* Sun Mar 06 2011 spuhler <spuhler> 5.2.31-2.mga1
+ Revision: 65725
- added Requires: python-paramiko
  It's neede otherwise the program doesn't start with error Cannot start SSH tunnel manager

* Mon Feb 28 2011 ahmad <ahmad> 5.2.31-1.mga1
+ Revision: 61371
- update to 5.2.31a
- rediff patch1,2,3
- add BR mysql-connector-c++-devel
- update the file list

  + dmorgan <dmorgan>
    - Apply patches 2 and 3
    - ONly apply patch4 for now
    - Add tinyxml-devel as buildrequire
    - Disable patch5
    - Fix build
    - Fix build
    - Fix %%setup
    - Fix source name
    - Add tartype macro
    - Apply patches
    - Fix desktop file name
    - Remove mdv macros
    - Rename spec file
      Fix version
      Fix URL
      Fix Sources0
      Add fedora patches
    - Rename to mysql-workbench
    - imported package mysql-workbench-oss

